# telegram.Bot

class telegram.Bot(token, base_url=None, base_file_url=None, request=None, private_key=None, private_key_password=None, defaults=None)

  Bases: `telegram.base.TelegramObject`

  This object represents a Telegram Bot.

  New in version 13.2: Objects of this class are comparable in terms of equality. Two objects of this class are considered equal, if their `bot` is equal.

  Note

  Most bot methods have the argument `api_kwargs` which allows to pass arbitrary keywords to the Telegram API. This can be used to access new features of the API before they were incorporated into PTB. However, this is not guaranteed to work, i.e. it will fail for passing files.

  Parameters

    - token (`str`) – Bot’s unique authentication.

    - base_url (`str`, optional) – Telegram Bot API service URL.

    - base_file_url (`str`, optional) – Telegram Bot API file URL.

    - request (`telegram.utils.request.Request`, optional) – Pre initialized `telegram.utils.request.Request`.

    - private_key (`bytes`, optional) – Private key for decryption of telegram passport data.

    - private_key_password (`bytes`, optional) – Password for above private key.

    - defaults (`telegram.ext.Defaults`, optional) –

      An object containing default values to be used if not set explicitly in the bot methods.

      Deprecated since version 13.6: Passing `telegram.ext.Defaults` to `telegram.Bot` is deprecated. If you want to use `telegram.ext.Defaults`, please use `telegram.ext.ExtBot` instead.

  addStickerToSet(user_id, name, emojis, png_sticker=None, mask_position=None, timeout=20, tgs_sticker=None, api_kwargs=None, webm_sticker=None)

    Alias for `add_sticker_to_set()`

  add_sticker_to_set(user_id, name, emojis, png_sticker=None, mask_position=None, timeout=20, tgs_sticker=None, api_kwargs=None, webm_sticker=None)

    Use this method to add a new sticker to a set created by the bot. You must use exactly one of the fields `png_sticker`, `tgs_sticker` or `webm_sticker`. Animated stickers can be added to animated sticker sets and only to them. Animated sticker sets can have up to 50 stickers. Static sticker sets can have up to 120 stickers.

    Warning

    As of API 4.7 `png_sticker` is an optional argument and therefore the order of the arguments had to be changed. Use keyword arguments to make sure that the arguments are passed correctly.

    Note

    The png_sticker and tgs_sticker argument can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    Parameters

      - user_id (`int`) – User identifier of created sticker set owner.

      - name (`str`) – Sticker set name.

      - png_sticker (`str` | filelike object | `bytes` | `pathlib.Path`, optional) –

        PNG image with the sticker, must be up to 512 kilobytes in size, dimensions must not exceed 512px, and either width or height must be exactly 512px. Pass a file_id as a String to send a file that already exists on the Telegram servers, pass an HTTP URL as a String for Telegram to get a file from the Internet, or upload a new one using multipart/form-data.

        Changed in version 13.2: Accept `bytes` as input.

      - tgs_sticker (`str` | filelike object | `bytes` | `pathlib.Path`, optional) –

        TGS animation with the sticker, uploaded using multipart/form-data. See https://core.telegram.org/stickers#animated-sticker-requirements for technical requirements.

        Changed in version 13.2: Accept `bytes` as input.

      - webm_sticker (`str` | file object | `bytes` | `pathlib.Path`, optional) –

        WEBM video with the sticker, uploaded using multipart/form-data. See https://core.telegram.org/stickers#video-sticker-requirements for technical requirements.

        New in version 13.11.

      - emojis (`str`) – One or more emoji corresponding to the sticker.

      - mask_position (`telegram.MaskPosition`, optional) – Position where the mask should be placed on faces.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  answerCallbackQuery(callback_query_id, text=None, show_alert=False, url=None, cache_time=None, timeout=None, api_kwargs=None)

    Alias for `answer_callback_query()`

  answerInlineQuery(inline_query_id, results, cache_time=300, is_personal=None, next_offset=None, switch_pm_text=None, switch_pm_parameter=None, timeout=None, current_offset=None, api_kwargs=None)

    Alias for `answer_inline_query()`

  answerPreCheckoutQuery(pre_checkout_query_id, ok, error_message=None, timeout=None, api_kwargs=None)

    Alias for `answer_pre_checkout_query()`

  answerShippingQuery(shipping_query_id, ok, shipping_options=None, error_message=None, timeout=None, api_kwargs=None)

    Alias for `answer_shipping_query()`

  answer_callback_query(callback_query_id, text=None, show_alert=False, url=None, cache_time=None, timeout=None, api_kwargs=None)

    Use this method to send answers to callback queries sent from inline keyboards. The answer will be displayed to the user as a notification at the top of the chat screen or as an alert. Alternatively, the user can be redirected to the specified Game URL. For this option to work, you must first create a game for your bot via @BotFather and accept the terms. Otherwise, you may use links like t.me/your_bot?start=XXXX that open your bot with a parameter.

    Parameters

      - callback_query_id (`str`) – Unique identifier for the query to be answered.

      - text (`str`, optional) – Text of the notification. If not specified, nothing will be shown to the user, 0-200 characters.

      - show_alert (`bool`, optional) – If `True`, an alert will be shown by the client instead of a notification at the top of the chat screen. Defaults to `False`.

      - url (`str`, optional) –

        URL that will be opened by the user’s client. If you have created a Game and accepted the conditions via @BotFather, specify the URL that opens your game - note that this will only work if the query comes from a callback game button. Otherwise, you may use links like t.me/your_bot?start=XXXX that open your bot with a parameter.

      - cache_time (`int`, optional) – The maximum amount of time in seconds that the result of the callback query may be cached client-side. Defaults to 0.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      `bool` On success, `True` is returned.

    Raises

      telegram.error.TelegramError –

  answer_inline_query(inline_query_id, results, cache_time=300, is_personal=None, next_offset=None, switch_pm_text=None, switch_pm_parameter=None, timeout=None, current_offset=None, api_kwargs=None)

    Use this method to send answers to an inline query. No more than 50 results per query are allowed.

    Warning

    In most use cases `current_offset` should not be passed manually. Instead of calling this method directly, use the shortcut `telegram.InlineQuery.answer()` with `auto_pagination=True`, which will take care of passing the correct value.

    Parameters

      - inline_query_id (`str`) – Unique identifier for the answered query.

      - results (List[`telegram.InlineQueryResult`] | Callable) – A list of results for the inline query. In case `current_offset` is passed, `results` may also be a callable that accepts the current page index starting from 0. It must return either a list of `telegram.InlineQueryResult` instances or `None` if there are no more results.

      - cache_time (`int`, optional) – The maximum amount of time in seconds that the result of the inline query may be cached on the server. Defaults to `300`.

      - is_personal (`bool`, optional) – Pass `True`, if results may be cached on the server side only for the user that sent the query. By default, results may be returned to any user who sends the same query.

      - next_offset (`str`, optional) – Pass the offset that a client should send in the next query with the same text to receive more results. Pass an empty string if there are no more results or if you don’t support pagination. Offset length can’t exceed 64 bytes.

      - switch_pm_text (`str`, optional) – If passed, clients will display a button with specified text that switches the user to a private chat with the bot and sends the bot a start message with the parameter `switch_pm_parameter`.

      - switch_pm_parameter (`str`, optional) – Deep-linking parameter for the /start message sent to the bot when user presses the switch button. 1-64 characters, only A-Z, a-z, 0-9, _ and - are allowed.

      - current_offset (`str`, optional) – The `telegram.InlineQuery.offset` of the inline query to answer. If passed, PTB will automatically take care of the pagination for you, i.e. pass the correct `next_offset` and truncate the results list/get the results from the callable you passed.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Example

    An inline bot that sends YouTube videos can ask the user to connect the bot to their YouTube account to adapt search results accordingly. To do this, it displays a ‘Connect your YouTube account’ button above the results, or even before showing any. The user presses the button, switches to a private chat with the bot and, in doing so, passes a start parameter that instructs the bot to return an oauth link. Once done, the bot can offer a switch_inline button so that the user can easily return to the chat where they wanted to use the bot’s inline capabilities.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  answer_pre_checkout_query(pre_checkout_query_id, ok, error_message=None, timeout=None, api_kwargs=None)

    Once the user has confirmed their payment and shipping details, the Bot API sends the final confirmation in the form of an `telegram.Update` with the field `Update.pre_checkout_query`. Use this method to respond to such pre-checkout queries.

    Note

    The Bot API must receive an answer within 10 seconds after the pre-checkout query was sent.

    Parameters

      - pre_checkout_query_id (`str`) – Unique identifier for the query to be answered.

      - ok (`bool`) – Specify `True` if everything is alright (goods are available, etc.) and the bot is ready to proceed with the order. Use `False` if there are any problems.

      - error_message (`str`, optional) – Required if ok is `False`. Error message in human readable form that explains the reason for failure to proceed with the checkout (e.g. “Sorry, somebody just bought the last of our amazing black T-shirts while you were busy filling out your payment details. Please choose a different color or garment!”). Telegram will display this message to the user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  answer_shipping_query(shipping_query_id, ok, shipping_options=None, error_message=None, timeout=None, api_kwargs=None)

    If you sent an invoice requesting a shipping address and the parameter `is_flexible` was specified, the Bot API will send an `telegram.Update` with a `Update.shipping_query` field to the bot. Use this method to reply to shipping queries.

    Parameters

      - shipping_query_id (`str`) – Unique identifier for the query to be answered.

      - ok (`bool`) – Specify `True` if delivery to the specified address is possible and `False` if there are any problems (for example, if delivery to the specified address is not possible).

      - shipping_options (List[`telegram.ShippingOption`]) – Required if ok is `True`. A JSON-serialized array of available shipping options.

      - error_message (`str`, optional) – Required if ok is `False`. Error message in human readable form that explains why it is impossible to complete the order (e.g. “Sorry, delivery to your desired address is unavailable”). Telegram will display this message to the user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  approveChatJoinRequest(chat_id, user_id, timeout=None, api_kwargs=None)

    Alias for `approve_chat_join_request()`

  approve_chat_join_request(chat_id, user_id, timeout=None, api_kwargs=None)

    Use this method to approve a chat join request.

    The bot must be an administrator in the chat for this to work and must have the `telegram.ChatPermissions.can_invite_users` administrator right.

    New in version 13.8.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - user_id (`int`) – Unique identifier of the target user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  banChatMember(chat_id, user_id, timeout=None, until_date=None, api_kwargs=None, revoke_messages=None)

    Alias for `ban_chat_member()`

  banChatSenderChat(chat_id, sender_chat_id, timeout=None, api_kwargs=None)

    Alias for `ban_chat_sender_chat()`

  ban_chat_member(chat_id, user_id, timeout=None, until_date=None, api_kwargs=None, revoke_messages=None)

    Use this method to ban a user from a group, supergroup or a channel. In the case of supergroups and channels, the user will not be able to return to the group on their own using invite links, etc., unless unbanned first. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights.

    > New in version 13.7.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target group or username of the target supergroup or channel (in the format `@channelusername`).

      - user_id (`int`) – Unique identifier of the target user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - until_date (`int` | `datetime.datetime`, optional) – Date when the user will be unbanned, unix time. If user is banned for more than 366 days or less than 30 seconds from the current time they are considered to be banned forever. Applied for supergroups and channels only. For timezone naive `datetime.datetime` objects, the default timezone of the bot will be used.

      - revoke_messages (`bool`, optional) –

        Pass `True` to delete all messages from the chat for the user that is being removed. If `False`, the user will be able to see messages in the group that were sent before the user was removed. Always `True` for supergroups and channels.

        New in version 13.4.

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  ban_chat_sender_chat(chat_id, sender_chat_id, timeout=None, api_kwargs=None)

    Use this method to ban a channel chat in a supergroup or a channel. Until the chat is unbanned, the owner of the banned chat won’t be able to send messages on behalf of any of their channels. The bot must be an administrator in the supergroup or channel for this to work and must have the appropriate administrator rights.

    New in version 13.9.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target group or username of the target supergroup or channel (in the format `@channelusername`).

      - sender_chat_id (`int`) – Unique identifier of the target sender chat.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  property bot

    User instance for the bot as returned by `get_me()`.

    Type

      `telegram.User`

  property can_join_groups

    Bot’s `telegram.User.can_join_groups` attribute.

    Type

      `bool`

  property can_read_all_group_messages

    Bot’s `telegram.User.can_read_all_group_messages` attribute.

    Type

      `bool`

  close(timeout=None)

    Use this method to close the bot instance before moving it from one local server to another. You need to delete the webhook before calling this method to ensure that the bot isn’t launched again after server restart. The method will return error 429 in the first 10 minutes after the bot is launched.

    Parameters

      timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

    Returns

      On success

    Return type

      `True`

    Raises

      telegram.error.TelegramError –

  property commands

    Bot’s commands as available in the default scope.

    Deprecated since version 13.7: This property has been deprecated since there can be different commands available for different scopes.

    Type

      List[`BotCommand`]

  copyMessage(chat_id, from_chat_id, message_id, caption=None, parse_mode=None, caption_entities=None, disable_notification=None, reply_to_message_id=None, allow_sending_without_reply=None, reply_markup=None, timeout=None, api_kwargs=None, protect_content=None)

    Alias for `copy_message()`

  copy_message(chat_id, from_chat_id, message_id, caption=None, parse_mode=None, caption_entities=None, disable_notification=None, reply_to_message_id=None, allow_sending_without_reply=None, reply_markup=None, timeout=None, api_kwargs=None, protect_content=None)

    Use this method to copy messages of any kind. Service messages and invoice messages can’t be copied. The method is analogous to the method `forward_message()`, but the copied message doesn’t have a link to the original message.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - from_chat_id (`int` | `str`) – Unique identifier for the chat where the original message was sent (or channel username in the format `@channelusername`).

      - message_id (`int`) – Message identifier in the chat specified in from_chat_id.

      - caption (`str`, optional) – New caption for media, 0-1024 characters after entities parsing. If not specified, the original caption is kept.

      - parse_mode (`str`, optional) – Mode for parsing entities in the new caption. See the constants in `telegram.ParseMode` for the available modes.

      - caption_entities (`telegram.utils.types.SLT[MessageEntity]`) – List of special entities that appear in the new caption, which can be specified instead of parse_mode

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success

    Return type

      `telegram.MessageId`

    Raises

      telegram.error.TelegramError –

  createChatInviteLink(chat_id, expire_date=None, member_limit=None, timeout=None, api_kwargs=None, name=None, creates_join_request=None)

    Alias for `create_chat_invite_link()`

  createNewStickerSet(user_id, name, title, emojis, png_sticker=None, contains_masks=None, mask_position=None, timeout=20, tgs_sticker=None, api_kwargs=None, webm_sticker=None)

    Alias for `create_new_sticker_set()`

  create_chat_invite_link(chat_id, expire_date=None, member_limit=None, timeout=None, api_kwargs=None, name=None, creates_join_request=None)

    Use this method to create an additional invite link for a chat. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. The link can be revoked using the method `revoke_chat_invite_link()`.

    New in version 13.4.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - expire_date (`int` | `datetime.datetime`, optional) – Date when the link will expire. Integer input will be interpreted as Unix timestamp. For timezone naive `datetime.datetime` objects, the default timezone of the bot will be used.

      - member_limit (`int`, optional) – Maximum number of users that can be members of the chat simultaneously after joining the chat via this invite link; 1-99999.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

      - name (`str`, optional) –

        Invite link name; 0-32 characters.

        New in version 13.8.

      - creates_join_request (`bool`, optional) –

        `True`, if users joining the chat via the link need to be approved by chat administrators. If `True`, `member_limit` can’t be specified.

        New in version 13.8.

    Returns

      `telegram.ChatInviteLink`

    Raises

      telegram.error.TelegramError –

  create_new_sticker_set(user_id, name, title, emojis, png_sticker=None, contains_masks=None, mask_position=None, timeout=20, tgs_sticker=None, api_kwargs=None, webm_sticker=None)

    Use this method to create new sticker set owned by a user. The bot will be able to edit the created sticker set. You must use exactly one of the fields `png_sticker`, `tgs_sticker`, or `webm_sticker`.

    Warning

    As of API 4.7 `png_sticker` is an optional argument and therefore the order of the arguments had to be changed. Use keyword arguments to make sure that the arguments are passed correctly.

    Note

    The png_sticker and tgs_sticker argument can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    Parameters

      - user_id (`int`) – User identifier of created sticker set owner.

      - name (`str`) – Short name of sticker set, to be used in t.me/addstickers/ URLs (e.g., animals). Can contain only english letters, digits and underscores. Must begin with a letter, can’t contain consecutive underscores and must end in “_by_<bot username>”. <bot_username> is case insensitive. 1-64 characters.

      - title (`str`) – Sticker set title, 1-64 characters.

      - png_sticker (`str` | filelike object | `bytes` | `pathlib.Path`, optional) –

        PNG image with the sticker, must be up to 512 kilobytes in size, dimensions must not exceed 512px, and either width or height must be exactly 512px. Pass a file_id as a String to send a file that already exists on the Telegram servers, pass an HTTP URL as a String for Telegram to get a file from the Internet, or upload a new one using multipart/form-data.

        Changed in version 13.2: Accept `bytes` as input.

      - tgs_sticker (`str` | filelike object | `bytes` | `pathlib.Path`, optional) –

        TGS animation with the sticker, uploaded using multipart/form-data. See https://core.telegram.org/stickers#animated-sticker-requirements for technical requirements.

        Changed in version 13.2: Accept `bytes` as input.

      - webm_sticker (`str` | file object | `bytes` | `pathlib.Path`, optional) –

        WEBM video with the sticker, uploaded using multipart/form-data. See https://core.telegram.org/stickers#video-sticker-requirements for technical requirements.

        New in version 13.11.

      - emojis (`str`) – One or more emoji corresponding to the sticker.

      - contains_masks (`bool`, optional) – Pass `True`, if a set of mask stickers should be created.

      - mask_position (`telegram.MaskPosition`, optional) – Position where the mask should be placed on faces.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  declineChatJoinRequest(chat_id, user_id, timeout=None, api_kwargs=None)

    Alias for `decline_chat_join_request()`

  decline_chat_join_request(chat_id, user_id, timeout=None, api_kwargs=None)

    Use this method to decline a chat join request.

    The bot must be an administrator in the chat for this to work and must have the `telegram.ChatPermissions.can_invite_users` administrator right.

    New in version 13.8.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - user_id (`int`) – Unique identifier of the target user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  deleteChatPhoto(chat_id, timeout=None, api_kwargs=None)

    Alias for `delete_chat_photo()`

  deleteChatStickerSet(chat_id, timeout=None, api_kwargs=None)

    Alias for `delete_chat_sticker_set()`

  deleteMessage(chat_id, message_id, timeout=None, api_kwargs=None)

    Alias for `delete_message()`

  deleteMyCommands(scope=None, language_code=None, api_kwargs=None, timeout=None)

    Alias for `delete_my_commands()`

  deleteStickerFromSet(sticker, timeout=None, api_kwargs=None)

    Alias for `delete_sticker_from_set()`

  deleteWebhook(timeout=None, api_kwargs=None, drop_pending_updates=None)

    Alias for `delete_webhook()`

  delete_chat_photo(chat_id, timeout=None, api_kwargs=None)

    Use this method to delete a chat photo. Photos can’t be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  delete_chat_sticker_set(chat_id, timeout=None, api_kwargs=None)

    Use this method to delete a group sticker set from a supergroup. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Use the field `telegram.Chat.can_set_sticker_set` optionally returned in `get_chat()` requests to check if the bot can use this method.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup (in the format @supergroupusername).

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

  delete_message(chat_id, message_id, timeout=None, api_kwargs=None)

    Use this method to delete a message, including service messages, with the following limitations:

    > - A message can only be deleted if it was sent less than 48 hours ago.

    > - A dice message in a private chat can only be deleted if it was sent more than 24 hours ago.

    > - Bots can delete outgoing messages in private chats, groups, and supergroups.

    > - Bots can delete incoming messages in private chats.

    > - Bots granted `telegram.ChatMember.can_post_messages` permissions can delete outgoing messages in channels.

    > - If the bot is an administrator of a group, it can delete any message there.

    > - If the bot has `telegram.ChatMember.can_delete_messages` permission in a supergroup or a channel, it can delete any message there.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - message_id (`int`) – Identifier of the message to delete.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  delete_my_commands(scope=None, language_code=None, api_kwargs=None, timeout=None)

    Use this method to delete the list of the bot’s commands for the given scope and user language. After deletion, higher level commands will be shown to affected users.

    New in version 13.7.

    Parameters

      - scope (`telegram.BotCommandScope`, optional) – A JSON-serialized object, describing scope of users for which the commands are relevant. Defaults to `telegram.BotCommandScopeDefault`.

      - language_code (`str`, optional) – A two-letter ISO 639-1 language code. If empty, commands will be applied to all users from the given scope, for whose language there are no dedicated commands.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  delete_sticker_from_set(sticker, timeout=None, api_kwargs=None)

    Use this method to delete a sticker from a set created by the bot.

    Parameters

      - sticker (`str`) – File identifier of the sticker.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  delete_webhook(timeout=None, api_kwargs=None, drop_pending_updates=None)

    Use this method to remove webhook integration if you decide to switch back to `get_updates()`.

    Parameters

      - drop_pending_updates (`bool`, optional) – Pass `True` to drop all pending updates.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  editChatInviteLink(chat_id, invite_link, expire_date=None, member_limit=None, timeout=None, api_kwargs=None, name=None, creates_join_request=None)

    Alias for `edit_chat_invite_link()`

  editMessageCaption(chat_id=None, message_id=None, inline_message_id=None, caption=None, reply_markup=None, timeout=None, parse_mode=None, api_kwargs=None, caption_entities=None)

    Alias for `edit_message_caption()`

  editMessageLiveLocation(chat_id=None, message_id=None, inline_message_id=None, latitude=None, longitude=None, location=None, reply_markup=None, timeout=None, api_kwargs=None, horizontal_accuracy=None, heading=None, proximity_alert_radius=None)

    Alias for `edit_message_live_location()`

  editMessageMedia(chat_id=None, message_id=None, inline_message_id=None, media=None, reply_markup=None, timeout=None, api_kwargs=None)

    Alias for `edit_message_media()`

  editMessageReplyMarkup(chat_id=None, message_id=None, inline_message_id=None, reply_markup=None, timeout=None, api_kwargs=None)

    Alias for `edit_message_reply_markup()`

  editMessageText(text, chat_id=None, message_id=None, inline_message_id=None, parse_mode=None, disable_web_page_preview=None, reply_markup=None, timeout=None, api_kwargs=None, entities=None)

    Alias for `edit_message_text()`

  edit_chat_invite_link(chat_id, invite_link, expire_date=None, member_limit=None, timeout=None, api_kwargs=None, name=None, creates_join_request=None)

    Use this method to edit a non-primary invite link created by the bot. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights.

    Note

    Though not stated explicitly in the official docs, Telegram changes not only the optional parameters that are explicitly passed, but also replaces all other optional parameters to the default values. However, since not documented, this behaviour may change unbeknown to PTB.

    New in version 13.4.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - invite_link (`str`) – The invite link to edit.

      - expire_date (`int` | `datetime.datetime`, optional) – Date when the link will expire. For timezone naive `datetime.datetime` objects, the default timezone of the bot will be used.

      - member_limit (`int`, optional) – Maximum number of users that can be members of the chat simultaneously after joining the chat via this invite link; 1-99999.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

      - name (`str`, optional) –

        Invite link name; 0-32 characters.

        New in version 13.8.

      - creates_join_request (`bool`, optional) –

        `True`, if users joining the chat via the link need to be approved by chat administrators. If `True`, `member_limit` can’t be specified.

        New in version 13.8.

    Returns

      `telegram.ChatInviteLink`

    Raises

      telegram.error.TelegramError –

  edit_message_caption(chat_id=None, message_id=None, inline_message_id=None, caption=None, reply_markup=None, timeout=None, parse_mode=None, api_kwargs=None, caption_entities=None)

    Use this method to edit captions of messages.

    Parameters

      - chat_id (`int` | `str`, optional) – Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format `@channelusername`)

      - message_id (`int`, optional) – Required if inline_message_id is not specified. Identifier of the message to edit.

      - inline_message_id (`str`, optional) – Required if chat_id and message_id are not specified. Identifier of the inline message.

      - caption (`str`, optional) – New caption of the message, 0-1024 characters after entities parsing.

      - parse_mode (`str`, optional) – Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption. See the constants in `telegram.ParseMode` for the available modes.

      - caption_entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - reply_markup (`telegram.InlineKeyboardMarkup`, optional) – A JSON-serialized object for an inline keyboard.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, if edited message is not an inline message, the edited message is returned, otherwise `True` is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  edit_message_live_location(chat_id=None, message_id=None, inline_message_id=None, latitude=None, longitude=None, location=None, reply_markup=None, timeout=None, api_kwargs=None, horizontal_accuracy=None, heading=None, proximity_alert_radius=None)

    Use this method to edit live location messages sent by the bot or via the bot (for inline bots). A location can be edited until its `telegram.Location.live_period` expires or editing is explicitly disabled by a call to `stop_message_live_location()`.

    Note

    You can either supply a `latitude` and `longitude` or a `location`.

    Parameters

      - chat_id (`int` | `str`, optional) – Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - message_id (`int`, optional) – Required if inline_message_id is not specified. Identifier of the message to edit.

      - inline_message_id (`str`, optional) – Required if chat_id and message_id are not specified. Identifier of the inline message.

      - latitude (`float`, optional) – Latitude of location.

      - longitude (`float`, optional) – Longitude of location.

      - location (`telegram.Location`, optional) – The location to send.

      - horizontal_accuracy (`float`, optional) – The radius of uncertainty for the location, measured in meters; 0-1500.

      - heading (`int`, optional) – Direction in which the user is moving, in degrees. Must be between 1 and 360 if specified.

      - proximity_alert_radius (`int`, optional) – Maximum distance for proximity alerts about approaching another chat member, in meters. Must be between 1 and 100000 if specified.

      - reply_markup (`telegram.InlineKeyboardMarkup`, optional) – A JSON-serialized object for a new inline keyboard.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, if edited message is not an inline message, the edited message is returned, otherwise `True` is returned.

    Return type

      `telegram.Message`

  edit_message_media(chat_id=None, message_id=None, inline_message_id=None, media=None, reply_markup=None, timeout=None, api_kwargs=None)

    Use this method to edit animation, audio, document, photo, or video messages. If a message is part of a message album, then it can be edited only to an audio for audio albums, only to a document for document albums and to a photo or a video otherwise. When an inline message is edited, a new file can’t be uploaded. Use a previously uploaded file via its `file_id` or specify a URL.

    Parameters

      - chat_id (`int` | `str`, optional) – Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - message_id (`int`, optional) – Required if inline_message_id is not specified. Identifier of the message to edit.

      - inline_message_id (`str`, optional) – Required if chat_id and message_id are not specified. Identifier of the inline message.

      - media (`telegram.InputMedia`) – An object for a new media content of the message.

      - reply_markup (`telegram.InlineKeyboardMarkup`, optional) – A JSON-serialized object for an inline keyboard.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, if edited message is sent by the bot, the edited Message is returned, otherwise `True` is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  edit_message_reply_markup(chat_id=None, message_id=None, inline_message_id=None, reply_markup=None, timeout=None, api_kwargs=None)

    Use this method to edit only the reply markup of messages sent by the bot or via the bot (for inline bots).

    Parameters

      - chat_id (`int` | `str`, optional) – Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - message_id (`int`, optional) – Required if inline_message_id is not specified. Identifier of the message to edit.

      - inline_message_id (`str`, optional) – Required if chat_id and message_id are not specified. Identifier of the inline message.

      - reply_markup (`telegram.InlineKeyboardMarkup`, optional) – A JSON-serialized object for an inline keyboard.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, if edited message is not an inline message, the edited message is returned, otherwise `True` is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  edit_message_text(text, chat_id=None, message_id=None, inline_message_id=None, parse_mode=None, disable_web_page_preview=None, reply_markup=None, timeout=None, api_kwargs=None, entities=None)

    Use this method to edit text and game messages.

    Parameters

      - chat_id (`int` | `str`, optional) – Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format `@channelusername`)

      - message_id (`int`, optional) – Required if inline_message_id is not specified. Identifier of the message to edit.

      - inline_message_id (`str`, optional) – Required if chat_id and message_id are not specified. Identifier of the inline message.

      - text (`str`) – New text of the message, 1-4096 characters after entities parsing.

      - parse_mode (`str`, optional) – Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in your bot’s message. See the constants in `telegram.ParseMode` for the available modes.

      - entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - disable_web_page_preview (`bool`, optional) – Disables link previews for links in this message.

      - reply_markup (`telegram.InlineKeyboardMarkup`, optional) – A JSON-serialized object for an inline keyboard.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, if edited message is not an inline message, the edited message is returned, otherwise `True` is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  exportChatInviteLink(chat_id, timeout=None, api_kwargs=None)

    Alias for `export_chat_invite_link()`

  export_chat_invite_link(chat_id, timeout=None, api_kwargs=None)

    Use this method to generate a new primary invite link for a chat; any previously generated link is revoked. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Note

    Each administrator in a chat generates their own invite links. Bots can’t use invite links generated by other administrators. If you want your bot to work with invite links, it will need to generate its own link using `export_chat_invite_link()` or by calling the `get_chat()` method. If your bot needs to generate a new primary invite link replacing its previous one, use `export_chat_invite_link` again.

    Returns

      New invite link on success.

    Return type

      `str`

    Raises

      telegram.error.TelegramError –

  property first_name

    Bot’s first name.

    Type

      `str`

  forwardMessage(chat_id, from_chat_id, message_id, disable_notification=None, timeout=None, api_kwargs=None, protect_content=None)

    Alias for `forward_message()`

  forward_message(chat_id, from_chat_id, message_id, disable_notification=None, timeout=None, api_kwargs=None, protect_content=None)

    Use this method to forward messages of any kind. Service messages can’t be forwarded.

    Note

    Since the release of Bot API 5.5 it can be impossible to forward messages from some chats. Use the attributes `telegram.Message.has_protected_content` and `telegram.Chat.has_protected_content` to check this.

    As a workaround, it is still possible to use `copy_message()`. However, this behaviour is undocumented and might be changed by Telegram.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - from_chat_id (`int` | `str`) – Unique identifier for the chat where the original message was sent (or channel username in the format `@channelusername`).

      - message_id (`int`) – Message identifier in the chat specified in from_chat_id.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  getChat(chat_id, timeout=None, api_kwargs=None)

    Alias for `get_chat()`

  getChatAdministrators(chat_id, timeout=None, api_kwargs=None)

    Alias for `get_chat_administrators()`

  getChatMember(chat_id, user_id, timeout=None, api_kwargs=None)

    Alias for `get_chat_member()`

  getChatMemberCount(chat_id, timeout=None, api_kwargs=None)

    Alias for `get_chat_member_count()`

  getChatMembersCount(chat_id, timeout=None, api_kwargs=None)

    Alias for `get_chat_members_count()`

  getFile(file_id, timeout=None, api_kwargs=None)

    Alias for `get_file()`

  getGameHighScores(user_id, chat_id=None, message_id=None, inline_message_id=None, timeout=None, api_kwargs=None)

    Alias for `get_game_high_scores()`

  getMe(timeout=None, api_kwargs=None)

    Alias for `get_me()`

  getMyCommands(timeout=None, api_kwargs=None, scope=None, language_code=None)

    Alias for `get_my_commands()`

  getStickerSet(name, timeout=None, api_kwargs=None)

    Alias for `get_sticker_set()`

  getUpdates(offset=None, limit=100, timeout=0, read_latency=2.0, allowed_updates=None, api_kwargs=None)

    Alias for `get_updates()`

  getUserProfilePhotos(user_id, offset=None, limit=100, timeout=None, api_kwargs=None)

    Alias for `get_user_profile_photos()`

  getWebhookInfo(timeout=None, api_kwargs=None)

    Alias for `get_webhook_info()`

  get_chat(chat_id, timeout=None, api_kwargs=None)

    Use this method to get up to date information about the chat (current name of the user for one-on-one conversations, current username of a user, group or channel, etc.).

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup or channel (in the format `@channelusername`).

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      `telegram.Chat`

    Raises

      telegram.error.TelegramError –

  get_chat_administrators(chat_id, timeout=None, api_kwargs=None)

    Use this method to get a list of administrators in a chat.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup or channel (in the format `@channelusername`).

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, returns a list of `ChatMember` objects that contains information about all chat administrators except other bots. If the chat is a group or a supergroup and no administrators were appointed, only the creator will be returned.

    Return type

      List[`telegram.ChatMember`]

    Raises

      telegram.error.TelegramError –

  get_chat_member(chat_id, user_id, timeout=None, api_kwargs=None)

    Use this method to get information about a member of a chat.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup or channel (in the format `@channelusername`).

      - user_id (`int`) – Unique identifier of the target user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      `telegram.ChatMember`

    Raises

      telegram.error.TelegramError –

  get_chat_member_count(chat_id, timeout=None, api_kwargs=None)

    Use this method to get the number of members in a chat.

    > New in version 13.7.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup or channel (in the format `@channelusername`).

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      Number of members in the chat.

    Return type

      `int`

    Raises

      telegram.error.TelegramError –

  get_chat_members_count(chat_id, timeout=None, api_kwargs=None)

    Deprecated, use `get_chat_member_count()` instead.

    Deprecated since version 13.7.

  get_file(file_id, timeout=None, api_kwargs=None)

    Use this method to get basic info about a file and prepare it for downloading. For the moment, bots can download files of up to 20MB in size. The file can then be downloaded with `telegram.File.download()`. It is guaranteed that the link will be valid for at least 1 hour. When the link expires, a new one can be requested by calling get_file again.

    Note

    This function may not preserve the original file name and MIME type. You should save the file’s MIME type and name (if available) when the File object is received.

    Parameters

      - file_id (`str` | `telegram.Animation` | `telegram.Audio` | `telegram.ChatPhoto` | `telegram.Document` | `telegram.PhotoSize` | `telegram.Sticker` | `telegram.Video` | `telegram.VideoNote` | `telegram.Voice`) – Either the file identifier or an object that has a file_id attribute to get file information about.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      `telegram.File`

    Raises

      telegram.error.TelegramError –

  get_game_high_scores(user_id, chat_id=None, message_id=None, inline_message_id=None, timeout=None, api_kwargs=None)

    Use this method to get data for high score tables. Will return the score of the specified user and several of their neighbors in a game.

    Note

    This method will currently return scores for the target user, plus two of their closest neighbors on each side. Will also return the top three users if the user and his neighbors are not among them. Please note that this behavior is subject to change.

    Parameters

      - user_id (`int`) – Target user id.

      - chat_id (`int` | `str`, optional) – Required if inline_message_id is not specified. Unique identifier for the target chat.

      - message_id (`int`, optional) – Required if inline_message_id is not specified. Identifier of the sent message.

      - inline_message_id (`str`, optional) – Required if chat_id and message_id are not specified. Identifier of the inline message.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      List[`telegram.GameHighScore`]

    Raises

      telegram.error.TelegramError –

  get_me(timeout=None, api_kwargs=None)

    A simple method for testing your bot’s auth token. Requires no parameters.

    Parameters

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      A `telegram.User` instance representing that bot if the credentials are valid, `None` otherwise.

    Return type

      `telegram.User`

    Raises

      telegram.error.TelegramError –

  get_my_commands(timeout=None, api_kwargs=None, scope=None, language_code=None)

    Use this method to get the current list of the bot’s commands for the given scope and user language.

    Parameters

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

      - scope (`telegram.BotCommandScope`, optional) –

        A JSON-serialized object, describing scope of users. Defaults to `telegram.BotCommandScopeDefault`.

        New in version 13.7.

      - language_code (`str`, optional) –

        A two-letter ISO 639-1 language code or an empty string.

        New in version 13.7.

    Returns

      On success, the commands set for the bot. An empty list is returned if commands are not set.

    Return type

      List[`telegram.BotCommand`]

    Raises

      telegram.error.TelegramError –

  get_sticker_set(name, timeout=None, api_kwargs=None)

    Use this method to get a sticker set.

    Parameters

      - name (`str`) – Name of the sticker set.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      `telegram.StickerSet`

    Raises

      telegram.error.TelegramError –

  get_updates(offset=None, limit=100, timeout=0, read_latency=2.0, allowed_updates=None, api_kwargs=None)

    Use this method to receive incoming updates using long polling.

    Parameters

      - offset (`int`, optional) – Identifier of the first update to be returned. Must be greater by one than the highest among the identifiers of previously received updates. By default, updates starting with the earliest unconfirmed update are returned. An update is considered confirmed as soon as getUpdates is called with an offset higher than its `telegram.Update.update_id`. The negative offset can be specified to retrieve updates starting from -offset update from the end of the updates queue. All previous updates will forgotten.

      - limit (`int`, optional) – Limits the number of updates to be retrieved. Values between 1-100 are accepted. Defaults to `100`.

      - timeout (`int`, optional) – Timeout in seconds for long polling. Defaults to `0`, i.e. usual short polling. Should be positive, short polling should be used for testing purposes only.

      - read_latency (`float` | `int`, optional) – Grace time in seconds for receiving the reply from server. Will be added to the `timeout` value and used as the read timeout from server. Defaults to `2`.

      - allowed_updates (List[`str`]), optional) – A JSON-serialized list the types of updates you want your bot to receive. For example, specify [“message”, “edited_channel_post”, “callback_query”] to only receive updates of these types. See `telegram.Update` for a complete list of available update types. Specify an empty list to receive all updates except `telegram.Update.chat_member` (default). If not specified, the previous setting will be used. Please note that this parameter doesn’t affect updates created before the call to the get_updates, so unwanted updates may be received for a short period of time.

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Note

    1. This method will not work if an outgoing webhook is set up.

    2. In order to avoid getting duplicate updates, recalculate offset after each server response.

    3. To take full advantage of this library take a look at `telegram.ext.Updater`

    Returns

      List[`telegram.Update`]

    Raises

      telegram.error.TelegramError –

  get_user_profile_photos(user_id, offset=None, limit=100, timeout=None, api_kwargs=None)

    Use this method to get a list of profile pictures for a user.

    Parameters

      - user_id (`int`) – Unique identifier of the target user.

      - offset (`int`, optional) – Sequential number of the first photo to be returned. By default, all photos are returned.

      - limit (`int`, optional) – Limits the number of photos to be retrieved. Values between 1-100 are accepted. Defaults to `100`.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      `telegram.UserProfilePhotos`

    Raises

      telegram.error.TelegramError –

  get_webhook_info(timeout=None, api_kwargs=None)

    Use this method to get current webhook status. Requires no parameters.

    If the bot is using `get_updates()`, will return an object with the `telegram.WebhookInfo.url` field empty.

    Parameters

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      `telegram.WebhookInfo`

  property id

    Unique identifier for this bot.

    Type

      `int`

  kickChatMember(chat_id, user_id, timeout=None, until_date=None, api_kwargs=None, revoke_messages=None)

    Alias for `kick_chat_member()`

  kick_chat_member(chat_id, user_id, timeout=None, until_date=None, api_kwargs=None, revoke_messages=None)

    Deprecated, use `ban_chat_member()` instead.

    Deprecated since version 13.7.

  property last_name

    Optional. Bot’s last name.

    Type

      `str`

  leaveChat(chat_id, timeout=None, api_kwargs=None)

    Alias for `leave_chat()`

  leave_chat(chat_id, timeout=None, api_kwargs=None)

    Use this method for your bot to leave a group, supergroup or channel.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup or channel (in the format `@channelusername`).

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  property link

    Convenience property. Returns the t.me link of the bot.

    Type

      `str`

  logOut(timeout=None)

    Alias for `log_out()`

  log_out(timeout=None)

    Use this method to log out from the cloud Bot API server before launching the bot locally. You must log out the bot before running it locally, otherwise there is no guarantee that the bot will receive updates. After a successful call, you can immediately log in on a local server, but will not be able to log in back to the cloud Bot API server for 10 minutes.

    Parameters

      timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

    Returns

      On success

    Return type

      `True`

    Raises

      telegram.error.TelegramError –

  property name

    Bot’s @username.

    Type

      `str`

  pinChatMessage(chat_id, message_id, disable_notification=None, timeout=None, api_kwargs=None)

    Alias for `pin_chat_message()`

  pin_chat_message(chat_id, message_id, disable_notification=None, timeout=None, api_kwargs=None)

    Use this method to add a message to the list of pinned messages in a chat. If the chat is not a private chat, the bot must be an administrator in the chat for this to work and must have the `telegram.ChatMember.can_pin_messages` admin right in a supergroup or `telegram.ChatMember.can_edit_messages` admin right in a channel.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - message_id (`int`) – Identifier of a message to pin.

      - disable_notification (`bool`, optional) – Pass `True`, if it is not necessary to send a notification to all chat members about the new pinned message. Notifications are always disabled in channels and private chats.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  promoteChatMember(chat_id, user_id, can_change_info=None, can_post_messages=None, can_edit_messages=None, can_delete_messages=None, can_invite_users=None, can_restrict_members=None, can_pin_messages=None, can_promote_members=None, timeout=None, api_kwargs=None, is_anonymous=None, can_manage_chat=None, can_manage_voice_chats=None)

    Alias for `promote_chat_member()`

  promote_chat_member(chat_id, user_id, can_change_info=None, can_post_messages=None, can_edit_messages=None, can_delete_messages=None, can_invite_users=None, can_restrict_members=None, can_pin_messages=None, can_promote_members=None, timeout=None, api_kwargs=None, is_anonymous=None, can_manage_chat=None, can_manage_voice_chats=None)

    Use this method to promote or demote a user in a supergroup or a channel. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Pass `False` for all boolean parameters to demote a user.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - user_id (`int`) – Unique identifier of the target user.

      - is_anonymous (`bool`, optional) – Pass `True`, if the administrator’s presence in the chat is hidden.

      - can_manage_chat (`bool`, optional) –

        Pass `True`, if the administrator can access the chat event log, chat statistics, message statistics in channels, see channel members, see anonymous administrators in supergroups and ignore slow mode. Implied by any other administrator privilege.

        New in version 13.4.

      - can_manage_voice_chats (`bool`, optional) –

        Pass `True`, if the administrator can manage voice chats.

        New in version 13.4.

      - can_change_info (`bool`, optional) – Pass `True`, if the administrator can change chat title, photo and other settings.

      - can_post_messages (`bool`, optional) – Pass `True`, if the administrator can create channel posts, channels only.

      - can_edit_messages (`bool`, optional) – Pass `True`, if the administrator can edit messages of other users and can pin messages, channels only.

      - can_delete_messages (`bool`, optional) – Pass `True`, if the administrator can delete messages of other users.

      - can_invite_users (`bool`, optional) – Pass `True`, if the administrator can invite new users to the chat.

      - can_restrict_members (`bool`, optional) – Pass `True`, if the administrator can restrict, ban or unban chat members.

      - can_pin_messages (`bool`, optional) – Pass `True`, if the administrator can pin messages, supergroups only.

      - can_promote_members (`bool`, optional) – Pass `True`, if the administrator can add new administrators with a subset of his own privileges or demote administrators that he has promoted, directly or indirectly (promoted by administrators that were appointed by him).

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  restrictChatMember(chat_id, user_id, permissions, until_date=None, timeout=None, api_kwargs=None)

    Alias for `restrict_chat_member()`

  restrict_chat_member(chat_id, user_id, permissions, until_date=None, timeout=None, api_kwargs=None)

    Use this method to restrict a user in a supergroup. The bot must be an administrator in the supergroup for this to work and must have the appropriate admin rights. Pass `True` for all boolean parameters to lift restrictions from a user.

    Note

    Since Bot API 4.4, `restrict_chat_member()` takes the new user permissions in a single argument of type `telegram.ChatPermissions`. The old way of passing parameters will not keep working forever.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup (in the format @supergroupusername).

      - user_id (`int`) – Unique identifier of the target user.

      - until_date (`int` | `datetime.datetime`, optional) – Date when restrictions will be lifted for the user, unix time. If user is restricted for more than 366 days or less than 30 seconds from the current time, they are considered to be restricted forever. For timezone naive `datetime.datetime` objects, the default timezone of the bot will be used.

      - permissions (`telegram.ChatPermissions`) – A JSON-serialized object for new user permissions.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  revokeChatInviteLink(chat_id, invite_link, timeout=None, api_kwargs=None)

    Alias for `revoke_chat_invite_link()`

  revoke_chat_invite_link(chat_id, invite_link, timeout=None, api_kwargs=None)

    Use this method to revoke an invite link created by the bot. If the primary link is revoked, a new link is automatically generated. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights.

    New in version 13.4.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - invite_link (`str`) – The invite link to edit.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      `telegram.ChatInviteLink`

    Raises

      telegram.error.TelegramError –

  sendAnimation(chat_id, animation, duration=None, width=None, height=None, thumb=None, caption=None, parse_mode=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Alias for `send_animation()`

  sendAudio(chat_id, audio, duration=None, performer=None, title=None, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, parse_mode=None, thumb=None, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Alias for `send_audio()`

  sendChatAction(chat_id, action, timeout=None, api_kwargs=None)

    Alias for `send_chat_action()`

  sendContact(chat_id, phone_number=None, first_name=None, last_name=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, contact=None, vcard=None, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Alias for `send_contact()`

  sendDice(chat_id, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, emoji=None, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Alias for `send_dice()`

  sendDocument(chat_id, document, filename=None, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, parse_mode=None, thumb=None, api_kwargs=None, disable_content_type_detection=None, allow_sending_without_reply=None, caption_entities=None, protect_content=None)

    Alias for `send_document()`

  sendGame(chat_id, game_short_name, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Alias for `send_game()`

  sendInvoice(chat_id, title, description, payload, provider_token, currency, prices, start_parameter=None, photo_url=None, photo_size=None, photo_width=None, photo_height=None, need_name=None, need_phone_number=None, need_email=None, need_shipping_address=None, is_flexible=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, provider_data=None, send_phone_number_to_provider=None, send_email_to_provider=None, timeout=None, api_kwargs=None, allow_sending_without_reply=None, max_tip_amount=None, suggested_tip_amounts=None, protect_content=None)

    Alias for `send_invoice()`

  sendLocation(chat_id, latitude=None, longitude=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, location=None, live_period=None, api_kwargs=None, horizontal_accuracy=None, heading=None, proximity_alert_radius=None, allow_sending_without_reply=None, protect_content=None)

    Alias for `send_location()`

  sendMediaGroup(chat_id, media, disable_notification=None, reply_to_message_id=None, timeout=20, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Alias for `send_media_group()`

  sendMessage(chat_id, text, parse_mode=None, disable_web_page_preview=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, api_kwargs=None, allow_sending_without_reply=None, entities=None, protect_content=None)

    Alias for `send_message()`

  sendPhoto(chat_id, photo, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, parse_mode=None, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Alias for `send_photo()`

  sendPoll(chat_id, question, options, is_anonymous=True, type='regular', allows_multiple_answers=False, correct_option_id=None, is_closed=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, explanation=None, explanation_parse_mode=None, open_period=None, close_date=None, api_kwargs=None, allow_sending_without_reply=None, explanation_entities=None, protect_content=None)

    Alias for `send_poll()`

  sendSticker(chat_id, sticker, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Alias for `send_sticker()`

  sendVenue(chat_id, latitude=None, longitude=None, title=None, address=None, foursquare_id=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, venue=None, foursquare_type=None, api_kwargs=None, google_place_id=None, google_place_type=None, allow_sending_without_reply=None, protect_content=None)

    Alias for `send_venue()`

  sendVideo(chat_id, video, duration=None, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, width=None, height=None, parse_mode=None, supports_streaming=None, thumb=None, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Alias for `send_video()`

  sendVideoNote(chat_id, video_note, duration=None, length=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, thumb=None, api_kwargs=None, allow_sending_without_reply=None, filename=None, protect_content=None)

    Alias for `send_video_note()`

  sendVoice(chat_id, voice, duration=None, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, parse_mode=None, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Alias for `send_voice()`

  send_animation(chat_id, animation, duration=None, width=None, height=None, thumb=None, caption=None, parse_mode=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Use this method to send animation files (GIF or H.264/MPEG-4 AVC video without sound). Bots can currently send animation files of up to 50 MB in size, this limit may be changed in the future.

    Note

    `thumb` will be ignored for small files, for which Telegram can easily generate thumb nails. However, this behaviour is undocumented and might be changed by Telegram.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - animation (`str` | filelike object | `bytes` | `pathlib.Path` | `telegram.Animation`) –

        Animation to send. Pass a file_id as String to send an animation that exists on the Telegram servers (recommended), pass an HTTP URL as a String for Telegram to get an animation from the Internet, or upload a new animation using multipart/form-data. Lastly you can pass an existing `telegram.Animation` object to send.

        Changed in version 13.2: Accept `bytes` as input.

      - filename (`str`, optional) –

        Custom file name for the animation, when uploading a new file. Convenience parameter, useful e.g. when sending files generated by the `tempfile` module.

        New in version 13.1.

      - duration (`int`, optional) – Duration of sent animation in seconds.

      - width (`int`, optional) – Animation width.

      - height (`int`, optional) – Animation height.

      - thumb (filelike object | `bytes` | `pathlib.Path`, optional) –

        Thumbnail of the file sent; can be ignored if thumbnail generation for the file is supported server-side. The thumbnail should be in JPEG format and less than 200 kB in size. A thumbnail’s width and height should not exceed 320. Ignored if the file is not uploaded using multipart/form-data. Thumbnails can’t be reused and can be only uploaded as a new file.

        Changed in version 13.2: Accept `bytes` as input.

      - caption (`str`, optional) – Animation caption (may also be used when resending animations by file_id), 0-1024 characters after entities parsing.

      - parse_mode (`str`, optional) – Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption. See the constants in `telegram.ParseMode` for the available modes.

      - caption_entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – Send file timeout (default: 20 seconds).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_audio(chat_id, audio, duration=None, performer=None, title=None, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, parse_mode=None, thumb=None, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Use this method to send audio files, if you want Telegram clients to display them in the music player. Your audio must be in the .mp3 or .m4a format.

    Bots can currently send audio files of up to 50 MB in size, this limit may be changed in the future.

    For sending voice messages, use the `send_voice()` method instead.

    Note

    The audio argument can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - audio (`str` | filelike object | `bytes` | `pathlib.Path` | `telegram.Audio`) –

        Audio file to send. Pass a file_id as String to send an audio file that exists on the Telegram servers (recommended), pass an HTTP URL as a String for Telegram to get an audio file from the Internet, or upload a new one using multipart/form-data. Lastly you can pass an existing `telegram.Audio` object to send.

        Changed in version 13.2: Accept `bytes` as input.

      - filename (`str`, optional) –

        Custom file name for the audio, when uploading a new file. Convenience parameter, useful e.g. when sending files generated by the `tempfile` module.

        New in version 13.1.

      - caption (`str`, optional) – Audio caption, 0-1024 characters after entities parsing.

      - parse_mode (`str`, optional) – Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption. See the constants in `telegram.ParseMode` for the available modes.

      - caption_entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - duration (`int`, optional) – Duration of sent audio in seconds.

      - performer (`str`, optional) – Performer.

      - title (`str`, optional) – Track name.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - thumb (filelike object | `bytes` | `pathlib.Path`, optional) –

        Thumbnail of the file sent; can be ignored if thumbnail generation for the file is supported server-side. The thumbnail should be in JPEG format and less than 200 kB in size. A thumbnail’s width and height should not exceed 320. Ignored if the file is not uploaded using multipart/form-data. Thumbnails can’t be reused and can be only uploaded as a new file.

        Changed in version 13.2: Accept `bytes` as input.

      - timeout (`int` | `float`, optional) – Send file timeout (default: 20 seconds).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_chat_action(chat_id, action, timeout=None, api_kwargs=None)

    Use this method when you need to tell the user that something is happening on the bot’s side. The status is set for 5 seconds or less (when a message arrives from your bot, Telegram clients clear its typing status). Telegram only recommends using this method when a response from the bot will take a noticeable amount of time to arrive.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - action (`telegram.ChatAction` | `str`) – Type of action to broadcast. Choose one, depending on what the user is about to receive. For convenience look at the constants in `telegram.ChatAction`

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  send_contact(chat_id, phone_number=None, first_name=None, last_name=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, contact=None, vcard=None, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Use this method to send phone contacts.

    Note

    You can either supply `contact` or `phone_number` and `first_name` with optionally `last_name` and optionally `vcard`.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - phone_number (`str`, optional) – Contact’s phone number.

      - first_name (`str`, optional) – Contact’s first name.

      - last_name (`str`, optional) – Contact’s last name.

      - vcard (`str`, optional) – Additional data about the contact in the form of a vCard, 0-2048 bytes.

      - contact (`telegram.Contact`, optional) – The contact to send.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_dice(chat_id, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, emoji=None, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Use this method to send an animated emoji that will display a random value.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - emoji (`str`, optional) –

        Emoji on which the dice throw animation is based. Currently, must be one of “🎲”, “🎯”, “🏀”, “⚽”, “🎳”, or “🎰”. Dice can have values 1-6 for “🎲”, “🎯” and “🎳”, values 1-5 for “🏀” and “⚽”, and values 1-64 for “🎰”. Defaults to “🎲”.

        Changed in version 13.4: Added the “🎳” emoji.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_document(chat_id, document, filename=None, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, parse_mode=None, thumb=None, api_kwargs=None, disable_content_type_detection=None, allow_sending_without_reply=None, caption_entities=None, protect_content=None)

    Use this method to send general files.

    Bots can currently send files of any type of up to 50 MB in size, this limit may be changed in the future.

    Note

    The document argument can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - document (`str` | filelike object | `bytes` | `pathlib.Path` | `telegram.Document`) –

        File to send. Pass a file_id as String to send a file that exists on the Telegram servers (recommended), pass an HTTP URL as a String for Telegram to get a file from the Internet, or upload a new one using multipart/form-data. Lastly you can pass an existing `telegram.Document` object to send.

        Changed in version 13.2: Accept `bytes` as input.

      - filename (`str`, optional) – Custom file name for the document, when uploading a new file. Convenience parameter, useful e.g. when sending files generated by the `tempfile` module.

      - caption (`str`, optional) – Document caption (may also be used when resending documents by file_id), 0-1024 characters after entities parsing.

      - disable_content_type_detection (`bool`, optional) – Disables automatic server-side content type detection for files uploaded using multipart/form-data.

      - parse_mode (`str`, optional) – Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption. See the constants in `telegram.ParseMode` for the available modes.

      - caption_entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - thumb (filelike object | `bytes` | `pathlib.Path`, optional) –

        Thumbnail of the file sent; can be ignored if thumbnail generation for the file is supported server-side. The thumbnail should be in JPEG format and less than 200 kB in size. A thumbnail’s width and height should not exceed 320. Ignored if the file is not uploaded using multipart/form-data. Thumbnails can’t be reused and can be only uploaded as a new file.

        Changed in version 13.2: Accept `bytes` as input.

      - timeout (`int` | `float`, optional) – Send file timeout (default: 20 seconds).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_game(chat_id, game_short_name, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Use this method to send a game.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat.

      - game_short_name (`str`) –

        Short name of the game, serves as the unique identifier for the game. Set up your games via @BotFather.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.InlineKeyboardMarkup`, optional) – A JSON-serialized object for a new inline keyboard. If empty, one ‘Play game_title’ button will be shown. If not empty, the first button must launch the game.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_invoice(chat_id, title, description, payload, provider_token, currency, prices, start_parameter=None, photo_url=None, photo_size=None, photo_width=None, photo_height=None, need_name=None, need_phone_number=None, need_email=None, need_shipping_address=None, is_flexible=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, provider_data=None, send_phone_number_to_provider=None, send_email_to_provider=None, timeout=None, api_kwargs=None, allow_sending_without_reply=None, max_tip_amount=None, suggested_tip_amounts=None, protect_content=None)

    Use this method to send invoices.

    Warning

    As of API 5.2 `start_parameter` is an optional argument and therefore the order of the arguments had to be changed. Use keyword arguments to make sure that the arguments are passed correctly.

    Changed in version 13.5: As of Bot API 5.2, the parameter `start_parameter` is optional.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - title (`str`) – Product name, 1-32 characters.

      - description (`str`) – Product description, 1-255 characters.

      - payload (`str`) – Bot-defined invoice payload, 1-128 bytes. This will not be displayed to the user, use for your internal processes.

      - provider_token (`str`) –

        Payments provider token, obtained via @BotFather.

      - currency (`str`) – Three-letter ISO 4217 currency code.

      - prices (List[`telegram.LabeledPrice`) – Price breakdown, a JSON-serialized list of components (e.g. product price, tax, discount, delivery cost, delivery tax, bonus, etc.).

      - max_tip_amount (`int`, optional) –

        The maximum accepted amount for tips in the smallest units of the currency (integer, not float/double). For example, for a maximum tip of US$ 1.45 pass `max_tip_amount = 145`. See the exp parameter in currencies.json, it shows the number of digits past the decimal point for each currency (2 for the majority of currencies). Defaults to `0`.

        New in version 13.5.

      - suggested_tip_amounts (List[`int`], optional) –

        A JSON-serialized array of suggested amounts of tips in the smallest units of the currency (integer, not float/double). At most 4 suggested tip amounts can be specified. The suggested tip amounts must be positive, passed in a strictly increased order and must not exceed `max_tip_amount`.

        New in version 13.5.

      - start_parameter (`str`, optional) –

        Unique deep-linking parameter. If left empty, forwarded copies of the sent message will have a Pay button, allowing multiple users to pay directly from the forwarded message, using the same invoice. If non-empty, forwarded copies of the sent message will have a URL button with a deep link to the bot (instead of a Pay button), with the value used as the start parameter.

        Changed in version 13.5: As of Bot API 5.2, this parameter is optional.

      - provider_data (`str` | `object`, optional) – JSON-serialized data about the invoice, which will be shared with the payment provider. A detailed description of required fields should be provided by the payment provider. When an object is passed, it will be encoded as JSON.

      - photo_url (`str`, optional) – URL of the product photo for the invoice. Can be a photo of the goods or a marketing image for a service. People like it better when they see what they are paying for.

      - photo_size (`str`, optional) – Photo size.

      - photo_width (`int`, optional) – Photo width.

      - photo_height (`int`, optional) – Photo height.

      - need_name (`bool`, optional) – Pass `True`, if you require the user’s full name to complete the order.

      - need_phone_number (`bool`, optional) – Pass `True`, if you require the user’s phone number to complete the order.

      - need_email (`bool`, optional) – Pass `True`, if you require the user’s email to complete the order.

      - need_shipping_address (`bool`, optional) – Pass `True`, if you require the user’s shipping address to complete the order.

      - send_phone_number_to_provider (`bool`, optional) – Pass `True`, if user’s phone number should be sent to provider.

      - send_email_to_provider (`bool`, optional) – Pass `True`, if user’s email address should be sent to provider.

      - is_flexible (`bool`, optional) – Pass `True`, if the final price depends on the shipping method.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.InlineKeyboardMarkup`, optional) – A JSON-serialized object for an inline keyboard. If empty, one ‘Pay total price’ button will be shown. If not empty, the first button must be a Pay button.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_location(chat_id, latitude=None, longitude=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, location=None, live_period=None, api_kwargs=None, horizontal_accuracy=None, heading=None, proximity_alert_radius=None, allow_sending_without_reply=None, protect_content=None)

    Use this method to send point on the map.

    Note

    You can either supply a `latitude` and `longitude` or a `location`.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - latitude (`float`, optional) – Latitude of location.

      - longitude (`float`, optional) – Longitude of location.

      - location (`telegram.Location`, optional) – The location to send.

      - horizontal_accuracy (`int`, optional) – The radius of uncertainty for the location, measured in meters; 0-1500.

      - live_period (`int`, optional) – Period in seconds for which the location will be updated, should be between 60 and 86400.

      - heading (`int`, optional) – For live locations, a direction in which the user is moving, in degrees. Must be between 1 and 360 if specified.

      - proximity_alert_radius (`int`, optional) – For live locations, a maximum distance for proximity alerts about approaching another chat member, in meters. Must be between 1 and 100000 if specified.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_media_group(chat_id, media, disable_notification=None, reply_to_message_id=None, timeout=20, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Use this method to send a group of photos or videos as an album.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - media (List[`telegram.InputMediaAudio`, `telegram.InputMediaDocument`, `telegram.InputMediaPhoto`, `telegram.InputMediaVideo`]) – An array describing messages to be sent, must include 2–10 items.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - timeout (`int` | `float`, optional) – Send file timeout (default: 20 seconds).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      An array of the sent Messages.

    Return type

      List[`telegram.Message`]

    Raises

      telegram.error.TelegramError –

  send_message(chat_id, text, parse_mode=None, disable_web_page_preview=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, api_kwargs=None, allow_sending_without_reply=None, entities=None, protect_content=None)

    Use this method to send text messages.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - text (`str`) – Text of the message to be sent. Max 4096 characters after entities parsing. Also found as `telegram.constants.MAX_MESSAGE_LENGTH`.

      - parse_mode (`str`) – Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in your bot’s message. See the constants in `telegram.ParseMode` for the available modes.

      - entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - disable_web_page_preview (`bool`, optional) – Disables link previews for links in this message.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of sent messages from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_photo(chat_id, photo, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, parse_mode=None, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Use this method to send photos.

    Note

    The photo argument can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - photo (`str` | filelike object | `bytes` | `pathlib.Path` | `telegram.PhotoSize`) –

        Photo to send. Pass a file_id as String to send a photo that exists on the Telegram servers (recommended), pass an HTTP URL as a String for Telegram to get a photo from the Internet, or upload a new photo using multipart/form-data. Lastly you can pass an existing `telegram.PhotoSize` object to send.

        Changed in version 13.2: Accept `bytes` as input.

      - filename (`str`, optional) –

        Custom file name for the photo, when uploading a new file. Convenience parameter, useful e.g. when sending files generated by the `tempfile` module.

        New in version 13.1.

      - caption (`str`, optional) – Photo caption (may also be used when resending photos by file_id), 0-1024 characters after entities parsing.

      - parse_mode (`str`, optional) – Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption. See the constants in `telegram.ParseMode` for the available modes.

      - caption_entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – Send file timeout (default: 20 seconds).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_poll(chat_id, question, options, is_anonymous=True, type='regular', allows_multiple_answers=False, correct_option_id=None, is_closed=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, explanation=None, explanation_parse_mode=None, open_period=None, close_date=None, api_kwargs=None, allow_sending_without_reply=None, explanation_entities=None, protect_content=None)

    Use this method to send a native poll.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - question (`str`) – Poll question, 1-300 characters.

      - options (List[`str`]) – List of answer options, 2-10 strings 1-100 characters each.

      - is_anonymous (`bool`, optional) – `True`, if the poll needs to be anonymous, defaults to `True`.

      - type (`str`, optional) – Poll type, `telegram.Poll.QUIZ` or `telegram.Poll.REGULAR`, defaults to `telegram.Poll.REGULAR`.

      - allows_multiple_answers (`bool`, optional) – `True`, if the poll allows multiple answers, ignored for polls in quiz mode, defaults to `False`.

      - correct_option_id (`int`, optional) – 0-based identifier of the correct answer option, required for polls in quiz mode.

      - explanation (`str`, optional) – Text that is shown when a user chooses an incorrect answer or taps on the lamp icon in a quiz-style poll, 0-200 characters with at most 2 line feeds after entities parsing.

      - explanation_parse_mode (`str`, optional) – Mode for parsing entities in the explanation. See the constants in `telegram.ParseMode` for the available modes.

      - explanation_entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - open_period (`int`, optional) – Amount of time in seconds the poll will be active after creation, 5-600. Can’t be used together with `close_date`.

      - close_date (`int` | `datetime.datetime`, optional) – Point in time (Unix timestamp) when the poll will be automatically closed. Must be at least 5 and no more than 600 seconds in the future. Can’t be used together with `open_period`. For timezone naive `datetime.datetime` objects, the default timezone of the bot will be used.

      - is_closed (`bool`, optional) – Pass `True`, if the poll needs to be immediately closed. This can be useful for poll preview.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_sticker(chat_id, sticker, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, api_kwargs=None, allow_sending_without_reply=None, protect_content=None)

    Use this method to send static `.WEBP`, animated `.TGS`, or video `.WEBM` stickers.

    Note

    The sticker argument can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - sticker (`str` | filelike object | `bytes` | `pathlib.Path` | `telegram.Sticker`) –

        Sticker to send. Pass a file_id as String to send a file that exists on the Telegram servers (recommended), pass an HTTP URL as a String for Telegram to get a .webp file from the Internet, or upload a new one using multipart/form-data. Lastly you can pass an existing `telegram.Sticker` object to send.

        Changed in version 13.2: Accept `bytes` as input.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – Send file timeout (default: 20 seconds).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_venue(chat_id, latitude=None, longitude=None, title=None, address=None, foursquare_id=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=None, venue=None, foursquare_type=None, api_kwargs=None, google_place_id=None, google_place_type=None, allow_sending_without_reply=None, protect_content=None)

    Use this method to send information about a venue.

    Note

    - You can either supply `venue`, or `latitude`, `longitude`, `title` and `address` and optionally `foursquare_id` and `foursquare_type` or optionally `google_place_id` and `google_place_type`.

    - Foursquare details and Google Pace details are mutually exclusive. However, this behaviour is undocumented and might be changed by Telegram.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - latitude (`float`, optional) – Latitude of venue.

      - longitude (`float`, optional) – Longitude of venue.

      - title (`str`, optional) – Name of the venue.

      - address (`str`, optional) – Address of the venue.

      - foursquare_id (`str`, optional) – Foursquare identifier of the venue.

      - foursquare_type (`str`, optional) – Foursquare type of the venue, if known. (For example, “arts_entertainment/default”, “arts_entertainment/aquarium” or “food/icecream”.)

      - google_place_id (`str`, optional) – Google Places identifier of the venue.

      - google_place_type (`str`, optional) – Google Places type of the venue. (See supported types.)

      - venue (`telegram.Venue`, optional) – The venue to send.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_video(chat_id, video, duration=None, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, width=None, height=None, parse_mode=None, supports_streaming=None, thumb=None, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Use this method to send video files, Telegram clients support mp4 videos (other formats may be sent as Document).

    Bots can currently send video files of up to 50 MB in size, this limit may be changed in the future.

    Note

    - The video argument can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    - `thumb` will be ignored for small video files, for which Telegram can easily generate thumb nails. However, this behaviour is undocumented and might be changed by Telegram.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - video (`str` | filelike object | `bytes` | `pathlib.Path` | `telegram.Video`) –

        Video file to send. Pass a file_id as String to send an video file that exists on the Telegram servers (recommended), pass an HTTP URL as a String for Telegram to get an video file from the Internet, or upload a new one using multipart/form-data. Lastly you can pass an existing `telegram.Video` object to send.

        Changed in version 13.2: Accept `bytes` as input.

      - filename (`str`, optional) –

        Custom file name for the video, when uploading a new file. Convenience parameter, useful e.g. when sending files generated by the `tempfile` module.

        New in version 13.1.

      - duration (`int`, optional) – Duration of sent video in seconds.

      - width (`int`, optional) – Video width.

      - height (`int`, optional) – Video height.

      - caption (`str`, optional) – Video caption (may also be used when resending videos by file_id), 0-1024 characters after entities parsing.

      - parse_mode (`str`, optional) – Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption. See the constants in `telegram.ParseMode` for the available modes.

      - caption_entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - supports_streaming (`bool`, optional) – Pass `True`, if the uploaded video is suitable for streaming.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - thumb (filelike object | `bytes` | `pathlib.Path`, optional) –

        Thumbnail of the file sent; can be ignored if thumbnail generation for the file is supported server-side. The thumbnail should be in JPEG format and less than 200 kB in size. A thumbnail’s width and height should not exceed 320. Ignored if the file is not uploaded using multipart/form-data. Thumbnails can’t be reused and can be only uploaded as a new file.

        Changed in version 13.2: Accept `bytes` as input.

      - timeout (`int` | `float`, optional) – Send file timeout (default: 20 seconds).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_video_note(chat_id, video_note, duration=None, length=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, thumb=None, api_kwargs=None, allow_sending_without_reply=None, filename=None, protect_content=None)

    As of v.4.0, Telegram clients support rounded square mp4 videos of up to 1 minute long. Use this method to send video messages.

    Note

    - The video_note argument can be either a file_id or a file from disk `open(filename, 'rb')`

    - `thumb` will be ignored for small video files, for which Telegram can easily generate thumb nails. However, this behaviour is undocumented and might be changed by Telegram.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - video_note (`str` | filelike object | `bytes` | `pathlib.Path` | `telegram.VideoNote`) –

        Video note to send. Pass a file_id as String to send a video note that exists on the Telegram servers (recommended) or upload a new video using multipart/form-data. Or you can pass an existing `telegram.VideoNote` object to send. Sending video notes by a URL is currently unsupported.

        Changed in version 13.2: Accept `bytes` as input.

      - filename (`str`, optional) –

        Custom file name for the video note, when uploading a new file. Convenience parameter, useful e.g. when sending files generated by the `tempfile` module.

        New in version 13.1.

      - duration (`int`, optional) – Duration of sent video in seconds.

      - length (`int`, optional) – Video width and height, i.e. diameter of the video message.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - thumb (filelike object | `bytes` | `pathlib.Path`, optional) –

        Thumbnail of the file sent; can be ignored if thumbnail generation for the file is supported server-side. The thumbnail should be in JPEG format and less than 200 kB in size. A thumbnail’s width and height should not exceed 320. Ignored if the file is not uploaded using multipart/form-data. Thumbnails can’t be reused and can be only uploaded as a new file.

        Changed in version 13.2: Accept `bytes` as input.

      - timeout (`int` | `float`, optional) – Send file timeout (default: 20 seconds).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  send_voice(chat_id, voice, duration=None, caption=None, disable_notification=None, reply_to_message_id=None, reply_markup=None, timeout=20, parse_mode=None, api_kwargs=None, allow_sending_without_reply=None, caption_entities=None, filename=None, protect_content=None)

    Use this method to send audio files, if you want Telegram clients to display the file as a playable voice message. For this to work, your audio must be in an .ogg file encoded with OPUS (other formats may be sent as Audio or Document). Bots can currently send voice messages of up to 50 MB in size, this limit may be changed in the future.

    Note

    The voice argument can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - voice (`str` | filelike object | `bytes` | `pathlib.Path` | `telegram.Voice`) –

        Voice file to send. Pass a file_id as String to send an voice file that exists on the Telegram servers (recommended), pass an HTTP URL as a String for Telegram to get an voice file from the Internet, or upload a new one using multipart/form-data. Lastly you can pass an existing `telegram.Voice` object to send.

        Changed in version 13.2: Accept `bytes` as input.

      - filename (`str`, optional) –

        Custom file name for the voice, when uploading a new file. Convenience parameter, useful e.g. when sending files generated by the `tempfile` module.

        New in version 13.1.

      - caption (`str`, optional) – Voice message caption, 0-1024 characters after entities parsing.

      - parse_mode (`str`, optional) – Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption. See the constants in `telegram.ParseMode` for the available modes.

      - caption_entities (List[`telegram.MessageEntity`], optional) – List of special entities that appear in message text, which can be specified instead of `parse_mode`.

      - duration (`int`, optional) – Duration of the voice message in seconds.

      - disable_notification (`bool`, optional) – Sends the message silently. Users will receive a notification with no sound.

      - protect_content (`bool`, optional) –

        Protects the contents of the sent message from forwarding and saving.

        New in version 13.10.

      - reply_to_message_id (`int`, optional) – If the message is a reply, ID of the original message.

      - allow_sending_without_reply (`bool`, optional) – Pass `True`, if the message should be sent even if the specified replied-to message is not found.

      - reply_markup (`telegram.ReplyMarkup`, optional) – Additional interface options. A JSON-serialized object for an inline keyboard, custom reply keyboard, instructions to remove reply keyboard or to force a reply from the user.

      - timeout (`int` | `float`, optional) – Send file timeout (default: 20 seconds).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the sent Message is returned.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError –

  setChatAdministratorCustomTitle(chat_id, user_id, custom_title, timeout=None, api_kwargs=None)

    Alias for `set_chat_administrator_custom_title()`

  setChatDescription(chat_id, description, timeout=None, api_kwargs=None)

    Alias for `set_chat_description()`

  setChatPermissions(chat_id, permissions, timeout=None, api_kwargs=None)

    Alias for `set_chat_permissions()`

  setChatPhoto(chat_id, photo, timeout=20, api_kwargs=None)

    Alias for `set_chat_photo()`

  setChatStickerSet(chat_id, sticker_set_name, timeout=None, api_kwargs=None)

    Alias for `set_chat_sticker_set()`

  setChatTitle(chat_id, title, timeout=None, api_kwargs=None)

    Alias for `set_chat_title()`

  setGameScore(user_id, score, chat_id=None, message_id=None, inline_message_id=None, force=None, disable_edit_message=None, timeout=None, api_kwargs=None)

    Alias for `set_game_score()`

  setMyCommands(commands, timeout=None, api_kwargs=None, scope=None, language_code=None)

    Alias for `set_my_commands()`

  setPassportDataErrors(user_id, errors, timeout=None, api_kwargs=None)

    Alias for `set_passport_data_errors()`

  setStickerPositionInSet(sticker, position, timeout=None, api_kwargs=None)

    Alias for `set_sticker_position_in_set()`

  setStickerSetThumb(name, user_id, thumb=None, timeout=None, api_kwargs=None)

    Alias for `set_sticker_set_thumb()`

  setWebhook(url=None, certificate=None, timeout=None, max_connections=40, allowed_updates=None, api_kwargs=None, ip_address=None, drop_pending_updates=None)

    Alias for `set_webhook()`

  set_chat_administrator_custom_title(chat_id, user_id, custom_title, timeout=None, api_kwargs=None)

    Use this method to set a custom title for administrators promoted by the bot in a supergroup. The bot must be an administrator for this to work.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup (in the format @supergroupusername).

      - user_id (`int`) – Unique identifier of the target administrator.

      - custom_title (`str`) – New custom title for the administrator; 0-16 characters, emoji are not allowed.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  set_chat_description(chat_id, description, timeout=None, api_kwargs=None)

    Use this method to change the description of a group, a supergroup or a channel. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - description (`str`) – New chat description, 0-255 characters.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  set_chat_permissions(chat_id, permissions, timeout=None, api_kwargs=None)

    Use this method to set default chat permissions for all members. The bot must be an administrator in the group or a supergroup for this to work and must have the `telegram.ChatMember.can_restrict_members` admin rights.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup (in the format @supergroupusername).

      - permissions (`telegram.ChatPermissions`) – New default chat permissions.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  set_chat_photo(chat_id, photo, timeout=20, api_kwargs=None)

    Use this method to set a new profile photo for the chat.

    Photos can’t be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - photo (filelike object | `bytes` | `pathlib.Path`) –

        New chat photo.

        Changed in version 13.2: Accept `bytes` as input.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  set_chat_sticker_set(chat_id, sticker_set_name, timeout=None, api_kwargs=None)

    Use this method to set a new group sticker set for a supergroup. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Use the field `telegram.Chat.can_set_sticker_set` optionally returned in `get_chat()` requests to check if the bot can use this method.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup (in the format @supergroupusername).

      - sticker_set_name (`str`) – Name of the sticker set to be set as the group sticker set.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

  set_chat_title(chat_id, title, timeout=None, api_kwargs=None)

    Use this method to change the title of a chat. Titles can’t be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - title (`str`) – New chat title, 1-255 characters.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  set_game_score(user_id, score, chat_id=None, message_id=None, inline_message_id=None, force=None, disable_edit_message=None, timeout=None, api_kwargs=None)

    Use this method to set the score of the specified user in a game.

    Parameters

      - user_id (`int`) – User identifier.

      - score (`int`) – New score, must be non-negative.

      - force (`bool`, optional) – Pass `True`, if the high score is allowed to decrease. This can be useful when fixing mistakes or banning cheaters.

      - disable_edit_message (`bool`, optional) – Pass `True`, if the game message should not be automatically edited to include the current scoreboard.

      - chat_id (`int` | `str`, optional) – Required if inline_message_id is not specified. Unique identifier for the target chat.

      - message_id (`int`, optional) – Required if inline_message_id is not specified. Identifier of the sent message.

      - inline_message_id (`str`, optional) – Required if chat_id and message_id are not specified. Identifier of the inline message.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      The edited message, or if the message wasn’t sent by the bot , `True`.

    Return type

      `telegram.Message`

    Raises

      telegram.error.TelegramError – If the new score is not greater than the user’s current score in the chat and force is `False`.

  set_my_commands(commands, timeout=None, api_kwargs=None, scope=None, language_code=None)

    Use this method to change the list of the bot’s commands. See the Telegram docs for more details about bot commands.

    Parameters

      - commands (List[`BotCommand` | (`str`, `str`)]) – A JSON-serialized list of bot commands to be set as the list of the bot’s commands. At most 100 commands can be specified.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

      - scope (`telegram.BotCommandScope`, optional) –

        A JSON-serialized object, describing scope of users for which the commands are relevant. Defaults to `telegram.BotCommandScopeDefault`.

        New in version 13.7.

      - language_code (`str`, optional) –

        A two-letter ISO 639-1 language code. If empty, commands will be applied to all users from the given scope, for whose language there are no dedicated commands.

        New in version 13.7.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  set_passport_data_errors(user_id, errors, timeout=None, api_kwargs=None)

    Informs a user that some of the Telegram Passport elements they provided contains errors. The user will not be able to re-submit their Passport to you until the errors are fixed (the contents of the field for which you returned the error must change).

    Use this if the data submitted by the user doesn’t satisfy the standards your service requires for any reason. For example, if a birthday date seems invalid, a submitted document is blurry, a scan shows evidence of tampering, etc. Supply some details in the error message to make sure the user knows how to correct the issues.

    Parameters

      - user_id (`int`) – User identifier

      - errors (List[`PassportElementError`]) – A JSON-serialized array describing the errors.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  set_sticker_position_in_set(sticker, position, timeout=None, api_kwargs=None)

    Use this method to move a sticker in a set created by the bot to a specific position.

    Parameters

      - sticker (`str`) – File identifier of the sticker.

      - position (`int`) – New sticker position in the set, zero-based.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  set_sticker_set_thumb(name, user_id, thumb=None, timeout=None, api_kwargs=None)

    Use this method to set the thumbnail of a sticker set. Animated thumbnails can be set for animated sticker sets only. Video thumbnails can be set only for video sticker sets only.

    Note

    The thumb can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    Parameters

      - name (`str`) – Sticker set name

      - user_id (`int`) – User identifier of created sticker set owner.

      - thumb (`str` | filelike object | `bytes` | `pathlib.Path`, optional) –

        A PNG image with the thumbnail, must be up to 128 kilobytes in size and have width and height exactly 100px, or a TGS animation with the thumbnail up to 32 kilobytes in size; see https://core.telegram.org/stickers#animated-sticker-requirements for animated sticker technical requirements, or a WEBM video with the thumbnail up to 32 kilobytes in size; see https://core.telegram.org/stickers#video-sticker-requirements for video sticker technical requirements. Pass a file_id as a String to send a file that already exists on the Telegram servers, pass an HTTP URL as a String for Telegram to get a file from the Internet, or upload a new one using multipart/form-data. Animated sticker set thumbnails can’t be uploaded via HTTP URL.

        Changed in version 13.2: Accept `bytes` as input.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  set_webhook(url=None, certificate=None, timeout=None, max_connections=40, allowed_updates=None, api_kwargs=None, ip_address=None, drop_pending_updates=None)

    Use this method to specify a url and receive incoming updates via an outgoing webhook. Whenever there is an update for the bot, Telegram will send an HTTPS POST request to the specified url, containing a JSON-serialized Update. In case of an unsuccessful request, Telegram will give up after a reasonable amount of attempts.

    If you’d like to make sure that the Webhook request comes from Telegram, Telegram recommends using a secret path in the URL, e.g. https://www.example.com/<token>. Since nobody else knows your bot’s token, you can be pretty sure it’s us.

    Note

    The certificate argument should be a file from disk `open(filename, 'rb')`.

    Parameters

      - url (`str`) – HTTPS url to send updates to. Use an empty string to remove webhook integration.

      - certificate (`filelike`) – Upload your public key certificate so that the root certificate in use can be checked. See our self-signed guide for details. (https://goo.gl/rw7w6Y)

      - ip_address (`str`, optional) – The fixed IP address which will be used to send webhook requests instead of the IP address resolved through DNS.

      - max_connections (`int`, optional) – Maximum allowed number of simultaneous HTTPS connections to the webhook for update delivery, 1-100. Defaults to `40`. Use lower values to limit the load on your bot’s server, and higher values to increase your bot’s throughput.

      - allowed_updates (List[`str`], optional) – A JSON-serialized list the types of updates you want your bot to receive. For example, specify [“message”, “edited_channel_post”, “callback_query”] to only receive updates of these types. See `telegram.Update` for a complete list of available update types. Specify an empty list to receive all updates except `telegram.Update.chat_member` (default). If not specified, the previous setting will be used. Please note that this parameter doesn’t affect updates created before the call to the set_webhook, so unwanted updates may be received for a short period of time.

      - drop_pending_updates (`bool`, optional) – Pass `True` to drop all pending updates.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Note

    1. You will not be able to receive updates using `get_updates()` for long as an outgoing webhook is set up.

    2. To use a self-signed certificate, you need to upload your public key certificate using certificate parameter. Please upload as InputFile, sending a String will not work.

    3. Ports currently supported for Webhooks: `443`, `80`, `88`, `8443`.

    If you’re having any trouble setting up webhooks, please check out this guide to Webhooks.

    Returns

      `bool` On success, `True` is returned.

    Raises

      telegram.error.TelegramError –

  stopMessageLiveLocation(chat_id=None, message_id=None, inline_message_id=None, reply_markup=None, timeout=None, api_kwargs=None)

    Alias for `stop_message_live_location()`

  stopPoll(chat_id, message_id, reply_markup=None, timeout=None, api_kwargs=None)

    Alias for `stop_poll()`

  stop_message_live_location(chat_id=None, message_id=None, inline_message_id=None, reply_markup=None, timeout=None, api_kwargs=None)

    Use this method to stop updating a live location message sent by the bot or via the bot (for inline bots) before live_period expires.

    Parameters

      - chat_id (`int` | `str`) – Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - message_id (`int`, optional) – Required if inline_message_id is not specified. Identifier of the sent message with live location to stop.

      - inline_message_id (`str`, optional) – Required if chat_id and message_id are not specified. Identifier of the inline message.

      - reply_markup (`telegram.InlineKeyboardMarkup`, optional) – A JSON-serialized object for a new inline keyboard.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, if edited message is sent by the bot, the sent Message is returned, otherwise `True` is returned.

    Return type

      `telegram.Message`

  stop_poll(chat_id, message_id, reply_markup=None, timeout=None, api_kwargs=None)

    Use this method to stop a poll which was sent by the bot.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - message_id (`int`) – Identifier of the original message with the poll.

      - reply_markup (`telegram.InlineKeyboardMarkup`, optional) – A JSON-serialized object for a new message inline keyboard.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the stopped Poll with the final results is returned.

    Return type

      `telegram.Poll`

    Raises

      telegram.error.TelegramError –

  property supports_inline_queries

    Bot’s `telegram.User.supports_inline_queries` attribute.

    Type

      `bool`

  to_dict()

    See `telegram.TelegramObject.to_dict()`.

  unbanChatMember(chat_id, user_id, timeout=None, api_kwargs=None, only_if_banned=None)

    Alias for `unban_chat_member()`

  unbanChatSenderChat(chat_id, sender_chat_id, timeout=None, api_kwargs=None)

    Alias for `unban_chat_sender_chat()`

  unban_chat_member(chat_id, user_id, timeout=None, api_kwargs=None, only_if_banned=None)

    Use this method to unban a previously kicked user in a supergroup or channel.

    The user will not return to the group or channel automatically, but will be able to join via link, etc. The bot must be an administrator for this to work. By default, this method guarantees that after the call the user is not a member of the chat, but will be able to join it. So if the user is a member of the chat they will also be removed from the chat. If you don’t want this, use the parameter `only_if_banned`.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup or channel (in the format `@channelusername`).

      - user_id (`int`) – Unique identifier of the target user.

      - only_if_banned (`bool`, optional) – Do nothing if the user is not banned.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  unban_chat_sender_chat(chat_id, sender_chat_id, timeout=None, api_kwargs=None)

    Use this method to unban a previously banned channel in a supergroup or channel. The bot must be an administrator for this to work and must have the appropriate administrator rights.

    New in version 13.9.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target supergroup or channel (in the format `@channelusername`).

      - sender_chat_id (`int`) – Unique identifier of the target sender chat.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  unpinAllChatMessages(chat_id, timeout=None, api_kwargs=None)

    Alias for `unpin_all_chat_messages()`

  unpinChatMessage(chat_id, timeout=None, api_kwargs=None, message_id=None)

    Alias for `unpin_chat_message()`

  unpin_all_chat_messages(chat_id, timeout=None, api_kwargs=None)

    Use this method to clear the list of pinned messages in a chat. If the chat is not a private chat, the bot must be an administrator in the chat for this to work and must have the `telegram.ChatMember.can_pin_messages` admin right in a supergroup or `telegram.ChatMember.can_edit_messages` admin right in a channel.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  unpin_chat_message(chat_id, timeout=None, api_kwargs=None, message_id=None)

    Use this method to remove a message from the list of pinned messages in a chat. If the chat is not a private chat, the bot must be an administrator in the chat for this to work and must have the `telegram.ChatMember.can_pin_messages` admin right in a supergroup or `telegram.ChatMember.can_edit_messages` admin right in a channel.

    Parameters

      - chat_id (`int` | `str`) – Unique identifier for the target chat or username of the target channel (in the format `@channelusername`).

      - message_id (`int`, optional) – Identifier of a message to unpin. If not specified, the most recent pinned message (by sending date) will be unpinned.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, `True` is returned.

    Return type

      `bool`

    Raises

      telegram.error.TelegramError –

  uploadStickerFile(user_id, png_sticker, timeout=20, api_kwargs=None)

    Alias for `upload_sticker_file()`

  upload_sticker_file(user_id, png_sticker, timeout=20, api_kwargs=None)

    Use this method to upload a `.PNG` file with a sticker for later use in `create_new_sticker_set()` and `add_sticker_to_set()` methods (can be used multiple times).

    Note

    The png_sticker argument can be either a file_id, an URL or a file from disk `open(filename, 'rb')`

    Parameters

      - user_id (`int`) – User identifier of sticker file owner.

      - png_sticker (`str` | filelike object | `bytes` | `pathlib.Path`) –

        PNG image with the sticker, must be up to 512 kilobytes in size, dimensions must not exceed 512px, and either width or height must be exactly 512px.

        Changed in version 13.2: Accept `bytes` as input.

      - timeout (`int` | `float`, optional) – If this value is specified, use it as the read timeout from the server (instead of the one specified during creation of the connection pool).

      - api_kwargs (`dict`, optional) – Arbitrary keyword arguments to be passed to the Telegram API.

    Returns

      On success, the uploaded File is returned.

    Return type

      `telegram.File`

    Raises

      telegram.error.TelegramError –

  property username

    Bot’s username.

    Type

      `str`